<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      size="small"
      :inline="true"
      v-show="showSearch"
      label-width="68px"
    >
      <el-form-item label="是否启用" prop="status">
        <el-select
          v-model="queryParams.status"
          placeholder="请选择"
          clearable
          filterable
        >
          <el-option
            v-for="dict in statusOpt"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button
          type="primary"
          icon="el-icon-search"
          size="mini"
          @click="handleQuery"
          >搜索</el-button
        >
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
          >重置</el-button
        >
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['business:NORMROLE:add']"
          >新增</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['business:NORMROLE:edit']"
          >修改</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['business:NORMROLE:remove']"
          >删除</el-button
        >
      </el-col>
      <!-- <el-col :span="1.5">
          <el-button
            type="warning"
            plain
            icon="el-icon-download"
            size="mini"
            @click="handleExport"
            v-hasPermi="['business:NORMROLE:export']"
            >导出</el-button
          >
        </el-col> -->
      <right-toolbar
        :showSearch.sync="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row>

    <el-table :data="NORMROLEList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />

      <el-table-column label="指标名称" align="center">
        <template slot-scope="scope">
          <!-- <el-link
              @click="tableBdClick(scope.row)"
              class="text-color"
              type="primaty"> -->
          {{ scope.row.fname }}
          <!-- </el-link> -->
        </template>
      </el-table-column>
      <el-table-column label="角色名称" align="center" prop="senId_dictText">
      </el-table-column>
      <el-table-column label="是否启用" align="center" prop="status">
        <template slot-scope="scope">
          <el-switch
            v-model="scope.row.status"
            @change="statusChange(scope.row)"
          ></el-switch>
        </template>
      </el-table-column>
      <el-table-column label="备注" align="center" prop="remark">
      </el-table-column>
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['business:NORMROLE:edit']"
            >修改</el-button
          >
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['business:NORMROLE:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改指标采集权限配置对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="35%" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="选择角色" prop="senId">
          <el-select filterable v-model="form.senId" placeholder="请选择">
            <el-option
              v-for="(item, i) in roleList"
              :key="item.value"
              :label="item.roleName"
              :value="item.roleId+''"
            >
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="选择指标" prop="feeId">
          <el-select filterable v-model="form.feeId" placeholder="请选择">
            <el-option
              v-for="(item, i) in indList"
              :key="item.value"
              :label="item.quotaName"
              :value="item.id"
            >
            </el-option>
          </el-select>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listNORMROLE,
  getNORMROLE,
  delNORMROLE,
  addNORMROLE,
  updateNORMROLE,
  setNORMROLEStop,
  setNORMROLEStart,
  listAllNORMROLE,
  getNORMROLEAllList,
} from "@/api/portal/RightDistribution/RightDistribution";
import { listQUOTAFEE } from "@/api/norm/QUOTAFEE";

import { listRole } from "@/api/system/role";

export default {
  name: "NORMROLE",
  data() {
    return {
      roleValue: "",
      indValue: "",

      statusOpt: [
        {
          label: "未启用",
          value: 0,
        },
        {
          label: "启用",
          value: 1,
        },
      ],
      // 根路径
      baseURL: process.env.VUE_APP_BASE_API,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 指标采集权限配置表格数据
      NORMROLEList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        nsType: 2,
        normId: null,
        id: null,
        createTime: null,
        createBy: null,
        updateTime: null,
        updateBy: null,
        delFlag: null,
        deptId: null,
        feeId: null,
        senId: null,
        status: null,
        startTime: null,
        stopTime: null,
        remark: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        roleId: [{ required: true, message: "角色不能为空", trigger: "blur" }],
        ind: [{ required: true, message: "指标不能为空", trigger: "blur" }],
        deptId: [
          { required: true, message: "部门id不能为空", trigger: "blur" },
        ],
        normId: [{ required: true, message: "指标不能为空", trigger: "blur" }],
        feeId: [{ required: true, message: "指标不能为空", trigger: "blur" }],
        senId: [{ required: true, message: "角色不能为空", trigger: "blur" }],
        status: [
          {
            required: true,
            message: "是否启用(1=启用,0不启用)不能为空",
            trigger: "blur",
          },
        ],
        startTime: [
          { required: true, message: "启用时间不能为空", trigger: "blur" },
        ],
        stopTime: [
          { required: true, message: "停用时间不能为空", trigger: "blur" },
        ],
        remark: [{ required: true, message: "备注不能为空", trigger: "blur" }],
      },
      indList: [],
      roleList: [],
    };
  },
  created() {
    this.getList();
    this.getNormroleallList();
    this.getRoleList();
  },
  methods: {
    changeInd(i) {
      this.form.feeId = this.indList[i].normId;
      this.form.fname = this.indList[i].normName;
    },
    changeRole(i) {
      this.form.senId = this.roleList[i].roleId;
    },
    statusChange(val) {
      if (val.status == 0) {
        setNORMROLEStart(val.id).then((res) => {
          if (res.code == 200) {
            this.$message.success("修改成功");
          }
        });
      } else {
        setNORMROLEStop(val.id).then((res) => {
          if (res.code == 200) {
            this.$message.success("修改成功");
          }
        });
      }
      this.getList();
    },

    tableBdClick(data) {
      this.queryParams.id = data.senId;
      listNORMROLE(this.pageParams).then((res) => {
        console.log(res);
      });
    },

    // 查询指标采集权限配置所有列表
    getNormroleallList() {
      listQUOTAFEE().then((res) => {
        this.indList = res.rows;
      });
    },

    // 查询角色列表
    getRoleList() {
      listRole().then((res) => {
        this.roleList = res.rows;
      });
    },
    /** 查询指标采集权限配置列表 */
    getList() {
      this.loading = true;
      listNORMROLE(this.queryParams).then((response) => {
        response.rows.forEach((item, index) => {
          response.rows[index].status = item.status == 0 ? false : true;
        });
        this.NORMROLEList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        delFlag: null,
        deptId: null,
        feeId: null,
        senId: null,
        status: null,
        startTime: null,
        stopTime: null,
        remark: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加辅助指标采集权限分配";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getNORMROLE(id).then((response) => {
        this.form = response.data;
        this.form.roleName = "张三";
        this.open = true;
        this.title = "修改辅助指标采集权限分配";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updateNORMROLE(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            this.form.nsType = 2;
            this.form.status = 1;
            addNORMROLE(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal
        .confirm('是否确认删除指标采集权限配置编号为"' + ids + '"的数据项？')
        .then(function () {
          return delNORMROLE(ids);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "/NORMROLE/export",
        {
          ...this.queryParams,
        },
        `NORMROLE_${new Date().getTime()}.xlsx`
      );
    },
  },
};
</script>
